/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2002 from the
 * contents of ClutterPath.xs. Do not edit this file, edit ClutterPath.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "xs/ClutterPath.xs"
#include "clutter-perl-private.h"

#define HFETCHIV(hv,key) \
        (((svp = hv_fetch ((hv), (key), strlen ((key)), FALSE)) \
          && gperl_sv_is_defined (*svp)                         \
          && SvIOK (*svp))                                      \
          ? SvIV (*svp)                                         \
          : 0)

#define AFETCHIV(av,index) \
        (((svp = av_fetch ((av), (index), FALSE))               \
          && gperl_sv_is_defined (*svp)                         \
          && SvIOK (*svp))                                      \
          ? SvIV (*svp)                                         \
          : 0)

static GPerlBoxedWrapperClass clutter_knot_wrapper_class;
static GPerlBoxedWrapperClass clutter_path_node_wrapper_class;

static ClutterPathNodeType
get_path_node_type_from_sv (SV *sv)
{
        gint retval = 0;

        if (!gperl_sv_is_defined (sv))
                croak ("Undefined node type");

        if (looks_like_number (sv)) {
                retval = SvIV (sv);
        }
        else {
                gboolean res;
                
                res = gperl_try_convert_enum (CLUTTER_TYPE_PATH_NODE_TYPE, sv, &retval);
                if (!res) {
                        croak ("Unable to convert node type");
                }
        }

        return retval;
}

static void
get_path_node_points_from_sv (SV *sv, ClutterPathNode *node)
{
        gint n_points, i;
        AV *av;

        if (node->type == CLUTTER_PATH_CLOSE)
                return;

        if (!sv || !SvOK (sv) || !SvRV (sv))
                croak ("The points of a path node must either be a single "
                       "ClutterKnot or a reference to an array of "
                       "ClutterKnots");

        switch (node->type) {
                case CLUTTER_PATH_MOVE_TO:
                case CLUTTER_PATH_REL_MOVE_TO:
                        n_points = 1;
                        break;

                case CLUTTER_PATH_LINE_TO:
                case CLUTTER_PATH_REL_LINE_TO:
                        n_points = 1;
                        break;

                case CLUTTER_PATH_CURVE_TO:
                case CLUTTER_PATH_REL_CURVE_TO:
                        n_points = 3;
                        break;
        }

        av = (AV *) SvRV (sv);

        if (av_len (av) != (n_points - 1))
                croak ("The path node requires %d %s",
                       n_points,
                       n_points > 1 ? "knots" : "knot");

        for (i = 0; i < n_points; i++) {
                SV **svp = av_fetch (av, i, 0);
                ClutterKnot *knot;

                knot = SvClutterKnot (*svp);
                node->points[i] = *knot;
        }
}

static SV *
clutter_knot_wrap (GType        gtype,
                   const gchar *package,
                   gpointer     boxed,
                   gboolean     own)
{
        ClutterKnot *knot = boxed;
        AV *av;

        if (!knot)
                return &PL_sv_undef;

        av = newAV ();
        av_push (av, newSViv (knot->x));
        av_push (av, newSViv (knot->y));

        if (own)
                clutter_knot_free (knot);
        
        return newRV_noinc ((SV *) av);
}

static void *
clutter_knot_unwrap (GType        gtype,
                     const gchar *package,
                     SV          *sv)
{
        ClutterKnot *knot;
        SV **svp;

        if (!sv || !SvOK (sv) || !SvRV (sv))
                return NULL;

        knot = gperl_alloc_temp (sizeof (ClutterKnot));

        switch (SvTYPE (SvRV (sv))) {
                case SVt_PVHV:
                {
                        HV *hv = (HV *) SvRV (sv);
                        knot->x = HFETCHIV (hv, "x");
                        knot->y = HFETCHIV (hv, "y");
                }
                        break;
                case SVt_PVAV:
                {
                        AV *av = (AV *) SvRV (sv);
                        knot->x = AFETCHIV (av, 0);
                        knot->y = AFETCHIV (av, 1);
                }
                        break;
                default:
                        croak ("a ClutterKnot must either be an array "
                               "or an hash with two values: x and y");
                        break;
       }

       return knot;
}

static SV *
clutter_path_node_wrap (GType        gtype,
                        const gchar *package,
                        gpointer     boxed,
                        gboolean     own)
{
        ClutterPathNode *node = boxed;
        HV *hv;
        AV *points = NULL;

        if (!node)
                return &PL_sv_undef;

        hv = newHV ();
        hv_store (hv, "type", 4, newSVClutterPathNodeType (node->type), 0);

        switch (node->type) {
                case CLUTTER_PATH_MOVE_TO:
                case CLUTTER_PATH_REL_MOVE_TO:
                        points = newAV ();
                        av_push (points, newSVClutterKnot_copy (&node->points[0]));
                        break;

                case CLUTTER_PATH_LINE_TO:
                case CLUTTER_PATH_REL_LINE_TO:
                        points = newAV ();
                        av_push (points, newSVClutterKnot_copy (&node->points[0]));
                        break;

                case CLUTTER_PATH_CURVE_TO:
                case CLUTTER_PATH_REL_CURVE_TO:
                        points = newAV ();
                        av_push (points, newSVClutterKnot_copy (&node->points[0]));
                        av_push (points, newSVClutterKnot_copy (&node->points[1]));
                        av_push (points, newSVClutterKnot_copy (&node->points[2]));
                        break;

                case CLUTTER_PATH_CLOSE:
                        points = newAV ();
                        break;
        }

        hv_store (hv, "points", 6, newRV_noinc ((SV *) points), 0);

        if (own)
                clutter_path_node_free (node);
        
        return newRV_noinc ((SV *) hv);
}

static void *
clutter_path_node_unwrap (GType        gtype,
                          const gchar *package,
                          SV          *sv)
{
        ClutterPathNode *node;
        gint enum_val = 0;
        SV **svp;

        if (!sv || !SvOK (sv) || !SvRV (sv))
                return NULL;

        node = gperl_alloc_temp (sizeof (ClutterPathNode));

        switch (SvTYPE (SvRV (sv))) {
                case SVt_PVHV:
                {
                        HV *hv = (HV *) SvRV (sv);
                        SV **svp;

                        svp = hv_fetch (hv, "type", 4, FALSE);
                        node->type = get_path_node_type_from_sv (*svp);

                        if (node->type == CLUTTER_PATH_CLOSE)
                                break;
                        else {
                                if (!hv_exists (hv, "points", 6)) {
                                        croak ("A node without points can only "
                                               "be of type 'close'");
                                }
                        }

                        svp = hv_fetch (hv, "points", 6, FALSE);
                        get_path_node_points_from_sv (*svp, node);
                }
                        break;

                case SVt_PVAV:
                {
                        AV *av = (AV *) SvRV (sv);
                        SV **svp;

                        svp = av_fetch (av, 0, 0);
                        node->type = get_path_node_type_from_sv (*svp);

                        if (node->type == CLUTTER_PATH_CLOSE)
                                break;
                        else {
                                if (av_len (av) == 0) {
                                        croak ("A node without points can only "
                                               "be of type 'close'");
                                }
                        }

                        svp = av_fetch (av, 1, 0);
                        get_path_node_points_from_sv (*svp, node);
                }
                        break;

                default:
                        croak ("a ClutterPathNode must either be an array or a hash");
                        break;
       }

       return node;
}

static void
clutterperl_path_sink (GObject *object)
{
        g_object_ref_sink (object);
        g_object_unref (object);
}

static GPerlCallback *
clutterperl_path_foreach_func_create (SV *func, SV *data)
{
        GType param_types[1];

        param_types[0] = CLUTTER_TYPE_PATH_NODE;

        return gperl_callback_new (func, data, 1, param_types, 0);
}

static void
clutterperl_path_foreach_func (const ClutterPathNode *node,
                               gpointer               data)
{
        gperl_callback_invoke ((GPerlCallback *) data, NULL, node);
}

#line 300 "xs/ClutterPath.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

#line 343 "xs/ClutterPath.c"

XS(XS_Clutter__Knot_equal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Knot_equal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "knot_a, knot_b");
    {
	gboolean	RETVAL;
	ClutterKnot *	knot_a = SvClutterKnot (ST(0));
	ClutterKnot *	knot_b = SvClutterKnot (ST(1));

	RETVAL = clutter_knot_equal(knot_a, knot_b);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Clutter__Path__Node_equal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path__Node_equal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "node_a, node_b");
    {
	gboolean	RETVAL;
	ClutterPathNode *	node_a = SvClutterPathNode (ST(0));
	ClutterPathNode *	node_b = SvClutterPathNode (ST(1));

	RETVAL = clutter_path_node_equal(node_a, node_b);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Clutter__Path_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    {
	ClutterPath_noinc *	RETVAL;
#line 412 "xs/ClutterPath.xs"
        RETVAL = clutter_path_new ();
        if (items == 2) {
                if (SvTYPE (ST (1)) == SVt_PV) {
                        clutter_path_set_description (RETVAL, SvPV_nolen (ST (1)));
                }
        }
        else {
                gint i;
                for (i = 1; i < items; i++) {
                        ClutterPathNode *node = SvClutterPathNode (ST (i));
                        clutter_path_add_node (RETVAL, node);
                }
        }
#line 417 "xs/ClutterPath.c"
	ST(0) = newSVClutterPath_noinc (RETVAL);

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Clutter__Path_set_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_set_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "path, description");
    {
	gboolean	RETVAL;
	ClutterPath *	path = SvClutterPath (ST(0));
	const gchar *	description;

	/* same as SvGChar(), but not in a function */
	sv_utf8_upgrade (ST(1));
	description = (const gchar *)SvPV_nolen (ST(1));

	RETVAL = clutter_path_set_description(path, description);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Clutter__Path_get_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_get_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "path");
    {
	const gchar_ornull *	RETVAL;
	ClutterPath *	path = SvClutterPath (ST(0));

	RETVAL = clutter_path_get_description(path);
	ST(0) = sv_newmortal();
	/* newSVGChar() allows NULL, but T_GCHAR does not. allow NULL. */
	if (RETVAL) {
		sv_setpv ((SV*)ST(0), RETVAL);
		SvUTF8_on (ST(0));
	} else {
		SvSetSV (ST(0), &PL_sv_undef);
	}

    }
    XSRETURN(1);
}


XS(XS_Clutter__Path_to_cairo_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_to_cairo_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "path, cr");
    {
	ClutterPath *	path = SvClutterPath (ST(0));
	cairo_t *	cr = SvCairo (ST(1));

	clutter_path_to_cairo_path(path, cr);
    }
    XSRETURN_EMPTY;
}


XS(XS_Clutter__Path_foreach); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_foreach)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "path, func, data=NULL");
    {
#line 464 "xs/ClutterPath.xs"
        GPerlCallback *cb;
#line 515 "xs/ClutterPath.c"
	ClutterPath *	path = SvClutterPath (ST(0));
	SV *	func = ST(1);
	SV *	data;

	if (items < 3)
	    data = NULL;
	else {
	    data = ST(2);
	}
#line 466 "xs/ClutterPath.xs"
        cb = clutterperl_path_foreach_func_create (func, data);
        clutter_path_foreach (path, clutterperl_path_foreach_func, cb);
        gperl_callback_destroy (cb);
#line 529 "xs/ClutterPath.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Clutter__Path_clear); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_clear)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "path");
    {
	ClutterPath *	path = SvClutterPath (ST(0));

	clutter_path_clear(path);
    }
    XSRETURN_EMPTY;
}


XS(XS_Clutter__Path_get_position); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_get_position)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "path, progress");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 489 "xs/ClutterPath.xs"
        guint index_;
        ClutterKnot knot;
#line 570 "xs/ClutterPath.c"
	ClutterPath *	path = SvClutterPath (ST(0));
	gdouble	progress = (double)SvNV(ST(1));
#line 492 "xs/ClutterPath.xs"
        index_ = clutter_path_get_position (path, progress, &knot);
        XPUSHs (sv_2mortal (newSVuv (index_)));
        if (GIMME_V == G_ARRAY) {
                XPUSHs (sv_2mortal (newSVClutterKnot (&knot)));
        }
#line 579 "xs/ClutterPath.c"
	PUTBACK;
	return;
    }
}


XS(XS_Clutter__Path_insert_node); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_insert_node)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "path, index, node");
    {
	ClutterPath *	path = SvClutterPath (ST(0));
	gint	index = (gint)SvIV(ST(1));
	ClutterPathNode *	node = SvClutterPathNode (ST(2));

	clutter_path_insert_node(path, index, node);
    }
    XSRETURN_EMPTY;
}


XS(XS_Clutter__Path_remove_node); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_remove_node)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "path, index");
    {
	ClutterPath *	path = SvClutterPath (ST(0));
	gint	index = (gint)SvIV(ST(1));

	clutter_path_remove_node(path, index);
    }
    XSRETURN_EMPTY;
}


XS(XS_Clutter__Path_replace_node); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_replace_node)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "path, index, node");
    {
	ClutterPath *	path = SvClutterPath (ST(0));
	gint	index = (gint)SvIV(ST(1));
	ClutterPathNode *	node = SvClutterPathNode (ST(2));

	clutter_path_replace_node(path, index, node);
    }
    XSRETURN_EMPTY;
}


XS(XS_Clutter__Path_get_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_get_length)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "path");
    {
	guint	RETVAL;
	dXSTARG;
	ClutterPath *	path = SvClutterPath (ST(0));

	RETVAL = clutter_path_get_length(path);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Clutter__Path_get_node); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_get_node)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "path, index");
    {
#line 523 "xs/ClutterPath.xs"
        ClutterPathNode node;
#line 683 "xs/ClutterPath.c"
	ClutterPathNode_copy *	RETVAL;
	ClutterPath *	path = SvClutterPath (ST(0));
	guint	index = (guint)SvUV(ST(1));
#line 525 "xs/ClutterPath.xs"
        clutter_path_get_node (path, index, &node);
        RETVAL = &node;
#line 690 "xs/ClutterPath.c"
	ST(0) = newSVClutterPathNode_copy (RETVAL);

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Clutter__Path_get_nodes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_get_nodes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "path");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 536 "xs/ClutterPath.xs"
        GSList *nodes, *l;
#line 714 "xs/ClutterPath.c"
	ClutterPath *	path = SvClutterPath (ST(0));
#line 538 "xs/ClutterPath.xs"
        nodes = clutter_path_get_nodes (path);
        EXTEND (SP, g_slist_length (nodes));
        for (l = nodes; l != NULL; l = l->next) {
                PUSHs (sv_2mortal (newSVClutterPathNode (l->data)));
        }
        g_slist_free (nodes);
#line 723 "xs/ClutterPath.c"
	PUTBACK;
	return;
    }
}


XS(XS_Clutter__Path_get_n_nodes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_get_n_nodes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "path");
    {
	guint	RETVAL;
	dXSTARG;
	ClutterPath *	path = SvClutterPath (ST(0));

	RETVAL = clutter_path_get_n_nodes(path);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Clutter__Path_add_move_to); /* prototype to pass -Wmissing-prototypes */
XS(XS_Clutter__Path_add_move_to)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "path, ...");
    {
	ClutterPath *	path = SvClutterPath (ST(0));
#line 644 "xs/ClutterPath.xs"
        switch (ix) {
                case 0: /* move-to */
                case 1: /* rel-move-to */
                        if (items != 3) {
                                croak ("Usage: Clutter::Path::add_move_to (path, x, y)");
                        }
                        if (ix == 0) {
                                clutter_path_add_move_to (path,
                                                          SvIV (ST (1)),
                                                          SvIV (ST (2)));
                        }
                        else {
                                clutter_path_add_rel_move_to (path,
                                                              SvIV (ST (1)),
                                                              SvIV (ST (2)));
                        }
                        break;
                case 2: /* line-to */
                case 3: /* rel-line-to */
                        if (items != 3) {
                                croak ("Usage: Clutter::Path::add_line_to (path, x, y)");
                        }
                        if (ix == 2) {
                                clutter_path_add_line_to (path,
                                                          SvIV (ST (1)),
                                                          SvIV (ST (2)));
                        }
                        else {
                                clutter_path_add_rel_line_to (path,
                                                              SvIV (ST (1)),
                                                              SvIV (ST (2)));
                        }
                        break;
                case 4: /* curve-to */
                case 5: /* rel-curve-to */
                        if (items != 7) {
                                croak ("Usage: Clutter::Path::add_curve_to (path, "
                                       "x1, y1, x2, y2, x3, y3)");
                        }
                        if (ix == 4) {
                                clutter_path_add_curve_to (path,
                                                           SvIV (ST (1)),
                                                           SvIV (ST (2)),
                                                           SvIV (ST (3)),
                                                           SvIV (ST (4)),
                                                           SvIV (ST (5)),
                                                           SvIV (ST (6)));
                        }
                        else {
                                clutter_path_add_rel_curve_to (path,
                                                               SvIV (ST (1)),
                                                               SvIV (ST (2)),
                                                               SvIV (ST (3)),
                                                               SvIV (ST (4)),
                                                               SvIV (ST (5)),
                                                               SvIV (ST (6)));
                        }
                        break;
                case 6:
                        if (items != 1) {
                                croak ("Usage: Clutter::Path::add_close (path)");
                        }
                        clutter_path_add_close (path);
                        break;
                case 7:
                        if (items != 2) {
                                croak ("Usage: Clutter::Path::add_string (path, string)");
                        }
                        if (!clutter_path_add_string (path, SvPV_nolen (ST (1))))
                            croak ("Invalid path description");
                        break;
        }
#line 838 "xs/ClutterPath.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Clutter__Path); /* prototype to pass -Wmissing-prototypes */
XS(boot_Clutter__Path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    const char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Clutter::Knot::equal", XS_Clutter__Knot_equal, file);
        newXS("Clutter::Path::Node::equal", XS_Clutter__Path__Node_equal, file);
        newXS("Clutter::Path::new", XS_Clutter__Path_new, file);
        newXS("Clutter::Path::set_description", XS_Clutter__Path_set_description, file);
        newXS("Clutter::Path::get_description", XS_Clutter__Path_get_description, file);
        newXS("Clutter::Path::to_cairo_path", XS_Clutter__Path_to_cairo_path, file);
        newXS("Clutter::Path::foreach", XS_Clutter__Path_foreach, file);
        newXS("Clutter::Path::clear", XS_Clutter__Path_clear, file);
        newXS("Clutter::Path::get_position", XS_Clutter__Path_get_position, file);
        newXS("Clutter::Path::insert_node", XS_Clutter__Path_insert_node, file);
        newXS("Clutter::Path::remove_node", XS_Clutter__Path_remove_node, file);
        newXS("Clutter::Path::replace_node", XS_Clutter__Path_replace_node, file);
        newXS("Clutter::Path::get_length", XS_Clutter__Path_get_length, file);
        newXS("Clutter::Path::get_node", XS_Clutter__Path_get_node, file);
        newXS("Clutter::Path::get_nodes", XS_Clutter__Path_get_nodes, file);
        newXS("Clutter::Path::get_n_nodes", XS_Clutter__Path_get_n_nodes, file);
        cv = newXS("Clutter::Path::add_rel_line_to", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 3 ;
        cv = newXS("Clutter::Path::add_line_to", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("Clutter::Path::add_move_to", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Clutter::Path::add_close", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 6 ;
        cv = newXS("Clutter::Path::add_string", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 7 ;
        cv = newXS("Clutter::Path::add_rel_curve_to", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 5 ;
        cv = newXS("Clutter::Path::add_curve_to", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 4 ;
        cv = newXS("Clutter::Path::add_rel_move_to", XS_Clutter__Path_add_move_to, file);
        XSANY.any_i32 = 1 ;
    }

    /* Initialisation Section */

#line 293 "xs/ClutterPath.xs"
        PERL_UNUSED_VAR (file);
        clutter_knot_wrapper_class = * gperl_default_boxed_wrapper_class ();
        clutter_knot_wrapper_class.wrap = clutter_knot_wrap;
        clutter_knot_wrapper_class.unwrap = clutter_knot_unwrap;
        gperl_register_boxed (CLUTTER_TYPE_KNOT, "Clutter::Knot",
                              &clutter_knot_wrapper_class);

#line 307 "xs/ClutterPath.xs"
        PERL_UNUSED_VAR (file);
        clutter_path_node_wrapper_class = * gperl_default_boxed_wrapper_class ();
        clutter_path_node_wrapper_class.wrap = clutter_path_node_wrap;
        clutter_path_node_wrapper_class.unwrap = clutter_path_node_unwrap;
        gperl_register_boxed (CLUTTER_TYPE_PATH_NODE, "Clutter::Path::Node",
                              &clutter_path_node_wrapper_class);

#line 367 "xs/ClutterPath.xs"
        gperl_register_sink_func (CLUTTER_TYPE_PATH, clutterperl_path_sink);

#line 918 "xs/ClutterPath.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

